; ##############################################################################
; ##############################################################################
; ##############################################################################
RDS_ROHDATEN_BERECHNUNG:
;-------------------------------------------------------------------------------
	; Gruppe-A aus SRAM laden				
	LDS temp2,(adr_RDS_AH)
	LDS temp1,(adr_RDS_AL)
	rcall RDS_CRC_TEMP1_2			; CRC	
	; "CRC"mit OFFSET_WORD_A verknpfen		
  	ldi  temp,low(OFFSET_WORD_A)
  	eor  temp1,temp
  	ldi  temp,high(OFFSET_WORD_A)
  	eor  temp2,temp
	; Zwischenergebnis speichern (10Bytes)	
	STS (adr_RDS_CRC_A_H),temp2
	STS (adr_RDS_CRC_A_L),temp1
;-------------------------------------------------------------------------------
	; Gruppe-B aus SRAM laden				
	LDS temp2,(adr_RDS_BH)
	LDS temp1,(adr_RDS_BL)
	rcall RDS_CRC_TEMP1_2			; CRC	
	; "CRC"mit OFFSET_WORD_B verknpfen		
  	ldi  temp,low(OFFSET_WORD_B)
  	eor  temp1,temp
  	ldi  temp,high(OFFSET_WORD_B)
  	eor  temp2,temp
	; Zwischenergebnis speichern (10Bytes)	
	STS (adr_RDS_CRC_B_H),temp2
	STS (adr_RDS_CRC_B_L),temp1
;-------------------------------------------------------------------------------
	; Gruppe-C aus SRAM laden				
	LDS temp2,(adr_RDS_CH)
	LDS temp1,(adr_RDS_CL)
	rcall RDS_CRC_TEMP1_2			; CRC	
	; "CRC"mit OFFSET_WORD_C verknpfen		
  	ldi  temp,low(OFFSET_WORD_C)
  	eor  temp1,temp
  	ldi  temp,high(OFFSET_WORD_C)
  	eor  temp2,temp
	; Zwischenergebnis speichern (10Bytes)	
	STS (adr_RDS_CRC_C_H),temp2
	STS (adr_RDS_CRC_C_L),temp1
;-------------------------------------------------------------------------------
	; Gruppe-D aus SRAM laden				
	LDS temp2,(adr_RDS_DH)
	LDS temp1,(adr_RDS_DL)
	rcall RDS_CRC_TEMP1_2			; CRC	
	; "CRC"mit OFFSET_WORD_D verknpfen		
  	ldi  temp,low(OFFSET_WORD_D)
  	eor  temp1,temp
  	ldi  temp,high(OFFSET_WORD_D)
  	eor  temp2,temp
	; Zwischenergebnis speichern (10Bytes)	
	STS (adr_RDS_CRC_D_H),temp2
	STS (adr_RDS_CRC_D_L),temp1
;-------------------------------------------------------------------------------
; Die Rohdaten im Vorpuffer schreiben											
	LDS temp2,(adr_RDS_AH)
	LDS temp1,(adr_RDS_AL)
	rcall RDS_SCHIEBEN_16_TEMP1_2	; DATEN in den Vorpuffer schieben		
	LDS temp2,(adr_RDS_CRC_A_H)
	LDS temp1,(adr_RDS_CRC_A_L)
	rcall RDS_SCHIEBEN_10_TEMP1_2	; PRFSUMME	in den Vorpuffer schieben	
;-------------------------------------------------------------------------------
	LDS temp2,(adr_RDS_BH)
	LDS temp1,(adr_RDS_BL)
	rcall RDS_SCHIEBEN_16_TEMP1_2	; DATEN in den Vorpuffer schieben		
	LDS temp2,(adr_RDS_CRC_B_H)
	LDS temp1,(adr_RDS_CRC_B_L)
	rcall RDS_SCHIEBEN_10_TEMP1_2	; PRFSUMME	in den Vorpuffer schieben	
;-------------------------------------------------------------------------------
	LDS temp2,(adr_RDS_CH)
	LDS temp1,(adr_RDS_CL)
	rcall RDS_SCHIEBEN_16_TEMP1_2	; DATEN in den Vorpuffer schieben		
	LDS temp2,(adr_RDS_CRC_C_H)
	LDS temp1,(adr_RDS_CRC_C_L)
	rcall RDS_SCHIEBEN_10_TEMP1_2	; PRFSUMME	in den Vorpuffer schieben	
;-------------------------------------------------------------------------------
	LDS temp2,(adr_RDS_DH)
	LDS temp1,(adr_RDS_DL)
	rcall RDS_SCHIEBEN_16_TEMP1_2	; DATEN in den Vorpuffer schieben		
	LDS temp2,(adr_RDS_CRC_D_H)
	LDS temp1,(adr_RDS_CRC_D_L)
	rcall RDS_SCHIEBEN_10_TEMP1_2	; PRFSUMME	in den Vorpuffer schieben	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; temp1+2  10 x schieben und vorher linksbndig									
RDS_SCHIEBEN_10_TEMP1_2:
	; Schleife			
	ldi temp9,6
RDS_SCHIEBEN_6_TEMP1_s:
	LSL temp1						; logisch links						
	ROL temp2						; 1x links ber Carry				
	dec temp9
	brne RDS_SCHIEBEN_6_TEMP1_s
;-------------------------------------------------------------------------------
	; Schleife			
	ldi temp9,10
RDS_SCHIEBEN_10_TEMP1_s:
	LSL temp1						; logisch links						
	ROL temp2						; 1x links ber Carry				
	rcall RDS_ROHDATEN_CARRY		; Carry schreiben					
	dec temp9
	brne RDS_SCHIEBEN_10_TEMP1_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; temp1+2  16 x schieben														
RDS_SCHIEBEN_16_TEMP1_2:
	; Schleife			
	ldi temp9,16
RDS_SCHIEBEN_16_TEMP1_s:
	LSL temp1						; logisch links						
	ROL temp2						; 1x links ber Carry				
	rcall RDS_ROHDATEN_CARRY		; Carry schreiben					
	dec temp9
	brne RDS_SCHIEBEN_16_TEMP1_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 13 SRAM Bytes = 104 Bits nach links schieben									
RDS_ROHDATEN_CARRY:
	push temp9
	push ZL
	push ZH
	; Z-initialisieren	
	ldi ZL,LOW (adr_VORBUFFER13+12)
	ldi ZH,HIGH(adr_VORBUFFER13+12)
	in temp,SREG	; Carry sichern
	; Schleife			
	ldi temp9,13
RDS_ROHDATEN_CARRY_s:
	out SREG,temp	; Carry wieder herstellen
	LD temp,Z						; aus SRAM laden		
	ROL temp						; 1x links ber Carry	
	ST Z,temp						; im SRAM ablegen Z-1	
	in temp,SREG	; Carry sichern			
	sbiw ZL,1
	dec temp9
	brne RDS_ROHDATEN_CARRY_s
	pop ZH
	pop ZL
	pop temp9
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CRC BERECHNUNG																
RDS_CRC_TEMP1_2:
	clr temp3 		; CRC (berechnet)		
	clr temp4
	; Schleife 1 "DATA" 16 x nach links
	ldi temp9,16
RDS_CRC_S1:
	LSL temp1		
	ROL temp2
	ROL temp3		; CRC (berechnet)		
	ROL temp4		; CRC (berechnet)		
	sbrs temp4,2	; Bit 10 gesetzt ?		
	rjmp RDS_CRC_S1_NO_XOR
	; XOR mit POLYNOM	
	ldi temp,LOW(POLYNOM)
	eor temp3,temp 	; CRC (berechnet)		
	ldi temp,HIGH(POLYNOM)
	eor temp4,temp 	; CRC (berechnet)		
RDS_CRC_S1_NO_XOR:
	dec temp9		; SCHLEIFE
	brne RDS_CRC_S1
;-------------------------------------------------------------------------------
	; Schleife 2 "CRC" 10 x nach links
	ldi temp9,10
RDS_CRC_S2:
	LSL temp3
	ROL temp4
	sbrs temp4,2	; Bit 10 gesetzt ?
	rjmp RDS_CRC_S2_NO_XOR
	; XOR mit POLYNOM	
	ldi temp,LOW(POLYNOM)
	eor temp3,temp 	; CRC (berechnet)		
	ldi temp,HIGH(POLYNOM)
	eor temp4,temp 	; CRC (berechnet)		
RDS_CRC_S2_NO_XOR:
	dec temp9		; SCHLEIFE
	brne RDS_CRC_S2
;-------------------------------------------------------------------------------
	; KOPIE					
	mov temp1,temp3
	mov temp2,temp4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################




